/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the OneDriveStorageRequestAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &OneDriveStorageRequestAllOf{}

// OneDriveStorageRequestAllOf struct for OneDriveStorageRequestAllOf
type OneDriveStorageRequestAllOf struct {
	OAuthId *int32         `json:"o_auth_id,omitempty"`
	Path    NullableString `json:"path,omitempty"`
	DriveId NullableString `json:"driveId,omitempty"`
	Tenant  NullableString `json:"tenant,omitempty"`
}

// NewOneDriveStorageRequestAllOf instantiates a new OneDriveStorageRequestAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewOneDriveStorageRequestAllOf() *OneDriveStorageRequestAllOf {
	this := OneDriveStorageRequestAllOf{}
	return &this
}

// NewOneDriveStorageRequestAllOfWithDefaults instantiates a new OneDriveStorageRequestAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewOneDriveStorageRequestAllOfWithDefaults() *OneDriveStorageRequestAllOf {
	this := OneDriveStorageRequestAllOf{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *OneDriveStorageRequestAllOf) GetOAuthId() int32 {
	if o == nil || IsNil(o.OAuthId) {
		var ret int32
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OneDriveStorageRequestAllOf) GetOAuthIdOk() (*int32, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *OneDriveStorageRequestAllOf) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given int32 and assigns it to the OAuthId field.
func (o *OneDriveStorageRequestAllOf) SetOAuthId(v int32) {
	o.OAuthId = &v
}

// GetPath returns the Path field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *OneDriveStorageRequestAllOf) GetPath() string {
	if o == nil || IsNil(o.Path.Get()) {
		var ret string
		return ret
	}
	return *o.Path.Get()
}

// GetPathOk returns a tuple with the Path field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *OneDriveStorageRequestAllOf) GetPathOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Path.Get(), o.Path.IsSet()
}

// HasPath returns a boolean if a field has been set.
func (o *OneDriveStorageRequestAllOf) HasPath() bool {
	if o != nil && o.Path.IsSet() {
		return true
	}

	return false
}

// SetPath gets a reference to the given NullableString and assigns it to the Path field.
func (o *OneDriveStorageRequestAllOf) SetPath(v string) {
	o.Path.Set(&v)
}

// SetPathNil sets the value for Path to be an explicit nil
func (o *OneDriveStorageRequestAllOf) SetPathNil() {
	o.Path.Set(nil)
}

// UnsetPath ensures that no value is present for Path, not even an explicit nil
func (o *OneDriveStorageRequestAllOf) UnsetPath() {
	o.Path.Unset()
}

// GetDriveId returns the DriveId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *OneDriveStorageRequestAllOf) GetDriveId() string {
	if o == nil || IsNil(o.DriveId.Get()) {
		var ret string
		return ret
	}
	return *o.DriveId.Get()
}

// GetDriveIdOk returns a tuple with the DriveId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *OneDriveStorageRequestAllOf) GetDriveIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.DriveId.Get(), o.DriveId.IsSet()
}

// HasDriveId returns a boolean if a field has been set.
func (o *OneDriveStorageRequestAllOf) HasDriveId() bool {
	if o != nil && o.DriveId.IsSet() {
		return true
	}

	return false
}

// SetDriveId gets a reference to the given NullableString and assigns it to the DriveId field.
func (o *OneDriveStorageRequestAllOf) SetDriveId(v string) {
	o.DriveId.Set(&v)
}

// SetDriveIdNil sets the value for DriveId to be an explicit nil
func (o *OneDriveStorageRequestAllOf) SetDriveIdNil() {
	o.DriveId.Set(nil)
}

// UnsetDriveId ensures that no value is present for DriveId, not even an explicit nil
func (o *OneDriveStorageRequestAllOf) UnsetDriveId() {
	o.DriveId.Unset()
}

// GetTenant returns the Tenant field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *OneDriveStorageRequestAllOf) GetTenant() string {
	if o == nil || IsNil(o.Tenant.Get()) {
		var ret string
		return ret
	}
	return *o.Tenant.Get()
}

// GetTenantOk returns a tuple with the Tenant field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *OneDriveStorageRequestAllOf) GetTenantOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Tenant.Get(), o.Tenant.IsSet()
}

// HasTenant returns a boolean if a field has been set.
func (o *OneDriveStorageRequestAllOf) HasTenant() bool {
	if o != nil && o.Tenant.IsSet() {
		return true
	}

	return false
}

// SetTenant gets a reference to the given NullableString and assigns it to the Tenant field.
func (o *OneDriveStorageRequestAllOf) SetTenant(v string) {
	o.Tenant.Set(&v)
}

// SetTenantNil sets the value for Tenant to be an explicit nil
func (o *OneDriveStorageRequestAllOf) SetTenantNil() {
	o.Tenant.Set(nil)
}

// UnsetTenant ensures that no value is present for Tenant, not even an explicit nil
func (o *OneDriveStorageRequestAllOf) UnsetTenant() {
	o.Tenant.Unset()
}

func (o OneDriveStorageRequestAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o OneDriveStorageRequestAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["o_auth_id"] = o.OAuthId
	}
	if o.Path.IsSet() {
		toSerialize["path"] = o.Path.Get()
	}
	if o.DriveId.IsSet() {
		toSerialize["driveId"] = o.DriveId.Get()
	}
	if o.Tenant.IsSet() {
		toSerialize["tenant"] = o.Tenant.Get()
	}
	return toSerialize, nil
}

type NullableOneDriveStorageRequestAllOf struct {
	value *OneDriveStorageRequestAllOf
	isSet bool
}

func (v NullableOneDriveStorageRequestAllOf) Get() *OneDriveStorageRequestAllOf {
	return v.value
}

func (v *NullableOneDriveStorageRequestAllOf) Set(val *OneDriveStorageRequestAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableOneDriveStorageRequestAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableOneDriveStorageRequestAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableOneDriveStorageRequestAllOf(val *OneDriveStorageRequestAllOf) *NullableOneDriveStorageRequestAllOf {
	return &NullableOneDriveStorageRequestAllOf{value: val, isSet: true}
}

func (v NullableOneDriveStorageRequestAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableOneDriveStorageRequestAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
